# coding: utf-8

"""
    DocuSign REST API

    The DocuSign REST API provides you with a powerful, convenient, and simple Web services API for interacting with DocuSign.  # noqa: E501

    OpenAPI spec version: v2.1
    Contact: devcenter@docusign.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from docusign_esign.client.configuration import Configuration


class BillingInvoice(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'amount': 'str',
        'balance': 'str',
        'due_date': 'str',
        'invoice_id': 'str',
        'invoice_items': 'list[BillingInvoiceItem]',
        'invoice_number': 'str',
        'invoice_uri': 'str',
        'non_taxable_amount': 'str',
        'pdf_available': 'str',
        'taxable_amount': 'str'
    }

    attribute_map = {
        'amount': 'amount',
        'balance': 'balance',
        'due_date': 'dueDate',
        'invoice_id': 'invoiceId',
        'invoice_items': 'invoiceItems',
        'invoice_number': 'invoiceNumber',
        'invoice_uri': 'invoiceUri',
        'non_taxable_amount': 'nonTaxableAmount',
        'pdf_available': 'pdfAvailable',
        'taxable_amount': 'taxableAmount'
    }

    def __init__(self, _configuration=None, **kwargs):  # noqa: E501
        """BillingInvoice - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._amount = None
        self._balance = None
        self._due_date = None
        self._invoice_id = None
        self._invoice_items = None
        self._invoice_number = None
        self._invoice_uri = None
        self._non_taxable_amount = None
        self._pdf_available = None
        self._taxable_amount = None
        self.discriminator = None

        setattr(self, "_{}".format('amount'), kwargs.get('amount', None))
        setattr(self, "_{}".format('balance'), kwargs.get('balance', None))
        setattr(self, "_{}".format('due_date'), kwargs.get('due_date', None))
        setattr(self, "_{}".format('invoice_id'), kwargs.get('invoice_id', None))
        setattr(self, "_{}".format('invoice_items'), kwargs.get('invoice_items', None))
        setattr(self, "_{}".format('invoice_number'), kwargs.get('invoice_number', None))
        setattr(self, "_{}".format('invoice_uri'), kwargs.get('invoice_uri', None))
        setattr(self, "_{}".format('non_taxable_amount'), kwargs.get('non_taxable_amount', None))
        setattr(self, "_{}".format('pdf_available'), kwargs.get('pdf_available', None))
        setattr(self, "_{}".format('taxable_amount'), kwargs.get('taxable_amount', None))

    @property
    def amount(self):
        """Gets the amount of this BillingInvoice.  # noqa: E501

        Reserved: TBD  # noqa: E501

        :return: The amount of this BillingInvoice.  # noqa: E501
        :rtype: str
        """
        return self._amount

    @amount.setter
    def amount(self, amount):
        """Sets the amount of this BillingInvoice.

        Reserved: TBD  # noqa: E501

        :param amount: The amount of this BillingInvoice.  # noqa: E501
        :type: str
        """

        self._amount = amount

    @property
    def balance(self):
        """Gets the balance of this BillingInvoice.  # noqa: E501

        Reserved: TBD  # noqa: E501

        :return: The balance of this BillingInvoice.  # noqa: E501
        :rtype: str
        """
        return self._balance

    @balance.setter
    def balance(self, balance):
        """Sets the balance of this BillingInvoice.

        Reserved: TBD  # noqa: E501

        :param balance: The balance of this BillingInvoice.  # noqa: E501
        :type: str
        """

        self._balance = balance

    @property
    def due_date(self):
        """Gets the due_date of this BillingInvoice.  # noqa: E501

        Reserved: TBD  # noqa: E501

        :return: The due_date of this BillingInvoice.  # noqa: E501
        :rtype: str
        """
        return self._due_date

    @due_date.setter
    def due_date(self, due_date):
        """Sets the due_date of this BillingInvoice.

        Reserved: TBD  # noqa: E501

        :param due_date: The due_date of this BillingInvoice.  # noqa: E501
        :type: str
        """

        self._due_date = due_date

    @property
    def invoice_id(self):
        """Gets the invoice_id of this BillingInvoice.  # noqa: E501

        Reserved: TBD  # noqa: E501

        :return: The invoice_id of this BillingInvoice.  # noqa: E501
        :rtype: str
        """
        return self._invoice_id

    @invoice_id.setter
    def invoice_id(self, invoice_id):
        """Sets the invoice_id of this BillingInvoice.

        Reserved: TBD  # noqa: E501

        :param invoice_id: The invoice_id of this BillingInvoice.  # noqa: E501
        :type: str
        """

        self._invoice_id = invoice_id

    @property
    def invoice_items(self):
        """Gets the invoice_items of this BillingInvoice.  # noqa: E501

        Reserved: TBD  # noqa: E501

        :return: The invoice_items of this BillingInvoice.  # noqa: E501
        :rtype: list[BillingInvoiceItem]
        """
        return self._invoice_items

    @invoice_items.setter
    def invoice_items(self, invoice_items):
        """Sets the invoice_items of this BillingInvoice.

        Reserved: TBD  # noqa: E501

        :param invoice_items: The invoice_items of this BillingInvoice.  # noqa: E501
        :type: list[BillingInvoiceItem]
        """

        self._invoice_items = invoice_items

    @property
    def invoice_number(self):
        """Gets the invoice_number of this BillingInvoice.  # noqa: E501

        Reserved: TBD  # noqa: E501

        :return: The invoice_number of this BillingInvoice.  # noqa: E501
        :rtype: str
        """
        return self._invoice_number

    @invoice_number.setter
    def invoice_number(self, invoice_number):
        """Sets the invoice_number of this BillingInvoice.

        Reserved: TBD  # noqa: E501

        :param invoice_number: The invoice_number of this BillingInvoice.  # noqa: E501
        :type: str
        """

        self._invoice_number = invoice_number

    @property
    def invoice_uri(self):
        """Gets the invoice_uri of this BillingInvoice.  # noqa: E501

        Contains a URI for an endpoint that you can use to retrieve invoice information.  # noqa: E501

        :return: The invoice_uri of this BillingInvoice.  # noqa: E501
        :rtype: str
        """
        return self._invoice_uri

    @invoice_uri.setter
    def invoice_uri(self, invoice_uri):
        """Sets the invoice_uri of this BillingInvoice.

        Contains a URI for an endpoint that you can use to retrieve invoice information.  # noqa: E501

        :param invoice_uri: The invoice_uri of this BillingInvoice.  # noqa: E501
        :type: str
        """

        self._invoice_uri = invoice_uri

    @property
    def non_taxable_amount(self):
        """Gets the non_taxable_amount of this BillingInvoice.  # noqa: E501

          # noqa: E501

        :return: The non_taxable_amount of this BillingInvoice.  # noqa: E501
        :rtype: str
        """
        return self._non_taxable_amount

    @non_taxable_amount.setter
    def non_taxable_amount(self, non_taxable_amount):
        """Sets the non_taxable_amount of this BillingInvoice.

          # noqa: E501

        :param non_taxable_amount: The non_taxable_amount of this BillingInvoice.  # noqa: E501
        :type: str
        """

        self._non_taxable_amount = non_taxable_amount

    @property
    def pdf_available(self):
        """Gets the pdf_available of this BillingInvoice.  # noqa: E501

          # noqa: E501

        :return: The pdf_available of this BillingInvoice.  # noqa: E501
        :rtype: str
        """
        return self._pdf_available

    @pdf_available.setter
    def pdf_available(self, pdf_available):
        """Sets the pdf_available of this BillingInvoice.

          # noqa: E501

        :param pdf_available: The pdf_available of this BillingInvoice.  # noqa: E501
        :type: str
        """

        self._pdf_available = pdf_available

    @property
    def taxable_amount(self):
        """Gets the taxable_amount of this BillingInvoice.  # noqa: E501

          # noqa: E501

        :return: The taxable_amount of this BillingInvoice.  # noqa: E501
        :rtype: str
        """
        return self._taxable_amount

    @taxable_amount.setter
    def taxable_amount(self, taxable_amount):
        """Sets the taxable_amount of this BillingInvoice.

          # noqa: E501

        :param taxable_amount: The taxable_amount of this BillingInvoice.  # noqa: E501
        :type: str
        """

        self._taxable_amount = taxable_amount

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(BillingInvoice, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, BillingInvoice):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, BillingInvoice):
            return True

        return self.to_dict() != other.to_dict()
