# coding: utf-8

"""
    DocuSign REST API

    The DocuSign REST API provides you with a powerful, convenient, and simple Web services API for interacting with DocuSign.  # noqa: E501

    OpenAPI spec version: v2.1
    Contact: devcenter@docusign.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from docusign_esign.client.configuration import Configuration


class BillingPaymentItem(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'amount': 'str',
        'description': 'str',
        'payment_date': 'str',
        'payment_id': 'str',
        'payment_number': 'str'
    }

    attribute_map = {
        'amount': 'amount',
        'description': 'description',
        'payment_date': 'paymentDate',
        'payment_id': 'paymentId',
        'payment_number': 'paymentNumber'
    }

    def __init__(self, _configuration=None, **kwargs):  # noqa: E501
        """BillingPaymentItem - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._amount = None
        self._description = None
        self._payment_date = None
        self._payment_id = None
        self._payment_number = None
        self.discriminator = None

        setattr(self, "_{}".format('amount'), kwargs.get('amount', None))
        setattr(self, "_{}".format('description'), kwargs.get('description', None))
        setattr(self, "_{}".format('payment_date'), kwargs.get('payment_date', None))
        setattr(self, "_{}".format('payment_id'), kwargs.get('payment_id', None))
        setattr(self, "_{}".format('payment_number'), kwargs.get('payment_number', None))

    @property
    def amount(self):
        """Gets the amount of this BillingPaymentItem.  # noqa: E501

        Reserved: TBD  # noqa: E501

        :return: The amount of this BillingPaymentItem.  # noqa: E501
        :rtype: str
        """
        return self._amount

    @amount.setter
    def amount(self, amount):
        """Sets the amount of this BillingPaymentItem.

        Reserved: TBD  # noqa: E501

        :param amount: The amount of this BillingPaymentItem.  # noqa: E501
        :type: str
        """

        self._amount = amount

    @property
    def description(self):
        """Gets the description of this BillingPaymentItem.  # noqa: E501

          # noqa: E501

        :return: The description of this BillingPaymentItem.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this BillingPaymentItem.

          # noqa: E501

        :param description: The description of this BillingPaymentItem.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def payment_date(self):
        """Gets the payment_date of this BillingPaymentItem.  # noqa: E501

          # noqa: E501

        :return: The payment_date of this BillingPaymentItem.  # noqa: E501
        :rtype: str
        """
        return self._payment_date

    @payment_date.setter
    def payment_date(self, payment_date):
        """Sets the payment_date of this BillingPaymentItem.

          # noqa: E501

        :param payment_date: The payment_date of this BillingPaymentItem.  # noqa: E501
        :type: str
        """

        self._payment_date = payment_date

    @property
    def payment_id(self):
        """Gets the payment_id of this BillingPaymentItem.  # noqa: E501

          # noqa: E501

        :return: The payment_id of this BillingPaymentItem.  # noqa: E501
        :rtype: str
        """
        return self._payment_id

    @payment_id.setter
    def payment_id(self, payment_id):
        """Sets the payment_id of this BillingPaymentItem.

          # noqa: E501

        :param payment_id: The payment_id of this BillingPaymentItem.  # noqa: E501
        :type: str
        """

        self._payment_id = payment_id

    @property
    def payment_number(self):
        """Gets the payment_number of this BillingPaymentItem.  # noqa: E501

        When set to **true**, a PDF version of the invoice is available.   To get the PDF, make the call again and change \"Accept:\" in the header to \"Accept: application/pdf\".  # noqa: E501

        :return: The payment_number of this BillingPaymentItem.  # noqa: E501
        :rtype: str
        """
        return self._payment_number

    @payment_number.setter
    def payment_number(self, payment_number):
        """Sets the payment_number of this BillingPaymentItem.

        When set to **true**, a PDF version of the invoice is available.   To get the PDF, make the call again and change \"Accept:\" in the header to \"Accept: application/pdf\".  # noqa: E501

        :param payment_number: The payment_number of this BillingPaymentItem.  # noqa: E501
        :type: str
        """

        self._payment_number = payment_number

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(BillingPaymentItem, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, BillingPaymentItem):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, BillingPaymentItem):
            return True

        return self.to_dict() != other.to_dict()
