# coding: utf-8

"""
    DocuSign REST API

    The DocuSign REST API provides you with a powerful, convenient, and simple Web services API for interacting with DocuSign.  # noqa: E501

    OpenAPI spec version: v2.1
    Contact: devcenter@docusign.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from docusign_esign.client.configuration import Configuration


class BrandsResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'brands': 'list[Brand]',
        'recipient_brand_id_default': 'str',
        'sender_brand_id_default': 'str'
    }

    attribute_map = {
        'brands': 'brands',
        'recipient_brand_id_default': 'recipientBrandIdDefault',
        'sender_brand_id_default': 'senderBrandIdDefault'
    }

    def __init__(self, _configuration=None, **kwargs):  # noqa: E501
        """BrandsResponse - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._brands = None
        self._recipient_brand_id_default = None
        self._sender_brand_id_default = None
        self.discriminator = None

        setattr(self, "_{}".format('brands'), kwargs.get('brands', None))
        setattr(self, "_{}".format('recipient_brand_id_default'), kwargs.get('recipient_brand_id_default', None))
        setattr(self, "_{}".format('sender_brand_id_default'), kwargs.get('sender_brand_id_default', None))

    @property
    def brands(self):
        """Gets the brands of this BrandsResponse.  # noqa: E501

        The list of brands.  # noqa: E501

        :return: The brands of this BrandsResponse.  # noqa: E501
        :rtype: list[Brand]
        """
        return self._brands

    @brands.setter
    def brands(self, brands):
        """Sets the brands of this BrandsResponse.

        The list of brands.  # noqa: E501

        :param brands: The brands of this BrandsResponse.  # noqa: E501
        :type: list[Brand]
        """

        self._brands = brands

    @property
    def recipient_brand_id_default(self):
        """Gets the recipient_brand_id_default of this BrandsResponse.  # noqa: E501

        The brand seen by envelope recipients when a brand is not explicitly set.  # noqa: E501

        :return: The recipient_brand_id_default of this BrandsResponse.  # noqa: E501
        :rtype: str
        """
        return self._recipient_brand_id_default

    @recipient_brand_id_default.setter
    def recipient_brand_id_default(self, recipient_brand_id_default):
        """Sets the recipient_brand_id_default of this BrandsResponse.

        The brand seen by envelope recipients when a brand is not explicitly set.  # noqa: E501

        :param recipient_brand_id_default: The recipient_brand_id_default of this BrandsResponse.  # noqa: E501
        :type: str
        """

        self._recipient_brand_id_default = recipient_brand_id_default

    @property
    def sender_brand_id_default(self):
        """Gets the sender_brand_id_default of this BrandsResponse.  # noqa: E501

        The brand seen by envelope senders when a brand is not explicitly set.  # noqa: E501

        :return: The sender_brand_id_default of this BrandsResponse.  # noqa: E501
        :rtype: str
        """
        return self._sender_brand_id_default

    @sender_brand_id_default.setter
    def sender_brand_id_default(self, sender_brand_id_default):
        """Sets the sender_brand_id_default of this BrandsResponse.

        The brand seen by envelope senders when a brand is not explicitly set.  # noqa: E501

        :param sender_brand_id_default: The sender_brand_id_default of this BrandsResponse.  # noqa: E501
        :type: str
        """

        self._sender_brand_id_default = sender_brand_id_default

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(BrandsResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, BrandsResponse):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, BrandsResponse):
            return True

        return self.to_dict() != other.to_dict()
