# coding: utf-8

"""
    DocuSign REST API

    The DocuSign REST API provides you with a powerful, convenient, and simple Web services API for interacting with DocuSign.  # noqa: E501

    OpenAPI spec version: v2.1
    Contact: devcenter@docusign.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from docusign_esign.client.configuration import Configuration


class BulkEnvelopeStatus(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'batch_id': 'str',
        'batch_size': 'str',
        'bulk_envelopes': 'list[BulkEnvelope]',
        'bulk_envelopes_batch_uri': 'str',
        'end_position': 'str',
        'failed': 'str',
        'next_uri': 'str',
        'previous_uri': 'str',
        'queued': 'str',
        'result_set_size': 'str',
        'sent': 'str',
        'start_position': 'str',
        'submitted_date': 'str',
        'total_set_size': 'str'
    }

    attribute_map = {
        'batch_id': 'batchId',
        'batch_size': 'batchSize',
        'bulk_envelopes': 'bulkEnvelopes',
        'bulk_envelopes_batch_uri': 'bulkEnvelopesBatchUri',
        'end_position': 'endPosition',
        'failed': 'failed',
        'next_uri': 'nextUri',
        'previous_uri': 'previousUri',
        'queued': 'queued',
        'result_set_size': 'resultSetSize',
        'sent': 'sent',
        'start_position': 'startPosition',
        'submitted_date': 'submittedDate',
        'total_set_size': 'totalSetSize'
    }

    def __init__(self, _configuration=None, **kwargs):  # noqa: E501
        """BulkEnvelopeStatus - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._batch_id = None
        self._batch_size = None
        self._bulk_envelopes = None
        self._bulk_envelopes_batch_uri = None
        self._end_position = None
        self._failed = None
        self._next_uri = None
        self._previous_uri = None
        self._queued = None
        self._result_set_size = None
        self._sent = None
        self._start_position = None
        self._submitted_date = None
        self._total_set_size = None
        self.discriminator = None

        setattr(self, "_{}".format('batch_id'), kwargs.get('batch_id', None))
        setattr(self, "_{}".format('batch_size'), kwargs.get('batch_size', None))
        setattr(self, "_{}".format('bulk_envelopes'), kwargs.get('bulk_envelopes', None))
        setattr(self, "_{}".format('bulk_envelopes_batch_uri'), kwargs.get('bulk_envelopes_batch_uri', None))
        setattr(self, "_{}".format('end_position'), kwargs.get('end_position', None))
        setattr(self, "_{}".format('failed'), kwargs.get('failed', None))
        setattr(self, "_{}".format('next_uri'), kwargs.get('next_uri', None))
        setattr(self, "_{}".format('previous_uri'), kwargs.get('previous_uri', None))
        setattr(self, "_{}".format('queued'), kwargs.get('queued', None))
        setattr(self, "_{}".format('result_set_size'), kwargs.get('result_set_size', None))
        setattr(self, "_{}".format('sent'), kwargs.get('sent', None))
        setattr(self, "_{}".format('start_position'), kwargs.get('start_position', None))
        setattr(self, "_{}".format('submitted_date'), kwargs.get('submitted_date', None))
        setattr(self, "_{}".format('total_set_size'), kwargs.get('total_set_size', None))

    @property
    def batch_id(self):
        """Gets the batch_id of this BulkEnvelopeStatus.  # noqa: E501

        Specifies an identifier which can be used to retrieve a more detailed status of individual bulk recipient batches.  # noqa: E501

        :return: The batch_id of this BulkEnvelopeStatus.  # noqa: E501
        :rtype: str
        """
        return self._batch_id

    @batch_id.setter
    def batch_id(self, batch_id):
        """Sets the batch_id of this BulkEnvelopeStatus.

        Specifies an identifier which can be used to retrieve a more detailed status of individual bulk recipient batches.  # noqa: E501

        :param batch_id: The batch_id of this BulkEnvelopeStatus.  # noqa: E501
        :type: str
        """

        self._batch_id = batch_id

    @property
    def batch_size(self):
        """Gets the batch_size of this BulkEnvelopeStatus.  # noqa: E501

        The number of items returned in this response.  # noqa: E501

        :return: The batch_size of this BulkEnvelopeStatus.  # noqa: E501
        :rtype: str
        """
        return self._batch_size

    @batch_size.setter
    def batch_size(self, batch_size):
        """Sets the batch_size of this BulkEnvelopeStatus.

        The number of items returned in this response.  # noqa: E501

        :param batch_size: The batch_size of this BulkEnvelopeStatus.  # noqa: E501
        :type: str
        """

        self._batch_size = batch_size

    @property
    def bulk_envelopes(self):
        """Gets the bulk_envelopes of this BulkEnvelopeStatus.  # noqa: E501

        Reserved: TBD  # noqa: E501

        :return: The bulk_envelopes of this BulkEnvelopeStatus.  # noqa: E501
        :rtype: list[BulkEnvelope]
        """
        return self._bulk_envelopes

    @bulk_envelopes.setter
    def bulk_envelopes(self, bulk_envelopes):
        """Sets the bulk_envelopes of this BulkEnvelopeStatus.

        Reserved: TBD  # noqa: E501

        :param bulk_envelopes: The bulk_envelopes of this BulkEnvelopeStatus.  # noqa: E501
        :type: list[BulkEnvelope]
        """

        self._bulk_envelopes = bulk_envelopes

    @property
    def bulk_envelopes_batch_uri(self):
        """Gets the bulk_envelopes_batch_uri of this BulkEnvelopeStatus.  # noqa: E501

        Reserved: TBD  # noqa: E501

        :return: The bulk_envelopes_batch_uri of this BulkEnvelopeStatus.  # noqa: E501
        :rtype: str
        """
        return self._bulk_envelopes_batch_uri

    @bulk_envelopes_batch_uri.setter
    def bulk_envelopes_batch_uri(self, bulk_envelopes_batch_uri):
        """Sets the bulk_envelopes_batch_uri of this BulkEnvelopeStatus.

        Reserved: TBD  # noqa: E501

        :param bulk_envelopes_batch_uri: The bulk_envelopes_batch_uri of this BulkEnvelopeStatus.  # noqa: E501
        :type: str
        """

        self._bulk_envelopes_batch_uri = bulk_envelopes_batch_uri

    @property
    def end_position(self):
        """Gets the end_position of this BulkEnvelopeStatus.  # noqa: E501

        The last position in the result set.   # noqa: E501

        :return: The end_position of this BulkEnvelopeStatus.  # noqa: E501
        :rtype: str
        """
        return self._end_position

    @end_position.setter
    def end_position(self, end_position):
        """Sets the end_position of this BulkEnvelopeStatus.

        The last position in the result set.   # noqa: E501

        :param end_position: The end_position of this BulkEnvelopeStatus.  # noqa: E501
        :type: str
        """

        self._end_position = end_position

    @property
    def failed(self):
        """Gets the failed of this BulkEnvelopeStatus.  # noqa: E501

        The number of entries with a status of failed.   # noqa: E501

        :return: The failed of this BulkEnvelopeStatus.  # noqa: E501
        :rtype: str
        """
        return self._failed

    @failed.setter
    def failed(self, failed):
        """Sets the failed of this BulkEnvelopeStatus.

        The number of entries with a status of failed.   # noqa: E501

        :param failed: The failed of this BulkEnvelopeStatus.  # noqa: E501
        :type: str
        """

        self._failed = failed

    @property
    def next_uri(self):
        """Gets the next_uri of this BulkEnvelopeStatus.  # noqa: E501

        The URI to the next chunk of records based on the search request. If the endPosition is the entire results of the search, this is null.   # noqa: E501

        :return: The next_uri of this BulkEnvelopeStatus.  # noqa: E501
        :rtype: str
        """
        return self._next_uri

    @next_uri.setter
    def next_uri(self, next_uri):
        """Sets the next_uri of this BulkEnvelopeStatus.

        The URI to the next chunk of records based on the search request. If the endPosition is the entire results of the search, this is null.   # noqa: E501

        :param next_uri: The next_uri of this BulkEnvelopeStatus.  # noqa: E501
        :type: str
        """

        self._next_uri = next_uri

    @property
    def previous_uri(self):
        """Gets the previous_uri of this BulkEnvelopeStatus.  # noqa: E501

        The postal code for the billing address.  # noqa: E501

        :return: The previous_uri of this BulkEnvelopeStatus.  # noqa: E501
        :rtype: str
        """
        return self._previous_uri

    @previous_uri.setter
    def previous_uri(self, previous_uri):
        """Sets the previous_uri of this BulkEnvelopeStatus.

        The postal code for the billing address.  # noqa: E501

        :param previous_uri: The previous_uri of this BulkEnvelopeStatus.  # noqa: E501
        :type: str
        """

        self._previous_uri = previous_uri

    @property
    def queued(self):
        """Gets the queued of this BulkEnvelopeStatus.  # noqa: E501

        The number of entries with a status of queued.   # noqa: E501

        :return: The queued of this BulkEnvelopeStatus.  # noqa: E501
        :rtype: str
        """
        return self._queued

    @queued.setter
    def queued(self, queued):
        """Sets the queued of this BulkEnvelopeStatus.

        The number of entries with a status of queued.   # noqa: E501

        :param queued: The queued of this BulkEnvelopeStatus.  # noqa: E501
        :type: str
        """

        self._queued = queued

    @property
    def result_set_size(self):
        """Gets the result_set_size of this BulkEnvelopeStatus.  # noqa: E501

        The number of results returned in this response.   # noqa: E501

        :return: The result_set_size of this BulkEnvelopeStatus.  # noqa: E501
        :rtype: str
        """
        return self._result_set_size

    @result_set_size.setter
    def result_set_size(self, result_set_size):
        """Sets the result_set_size of this BulkEnvelopeStatus.

        The number of results returned in this response.   # noqa: E501

        :param result_set_size: The result_set_size of this BulkEnvelopeStatus.  # noqa: E501
        :type: str
        """

        self._result_set_size = result_set_size

    @property
    def sent(self):
        """Gets the sent of this BulkEnvelopeStatus.  # noqa: E501

        The number of entries with a status of sent.  # noqa: E501

        :return: The sent of this BulkEnvelopeStatus.  # noqa: E501
        :rtype: str
        """
        return self._sent

    @sent.setter
    def sent(self, sent):
        """Sets the sent of this BulkEnvelopeStatus.

        The number of entries with a status of sent.  # noqa: E501

        :param sent: The sent of this BulkEnvelopeStatus.  # noqa: E501
        :type: str
        """

        self._sent = sent

    @property
    def start_position(self):
        """Gets the start_position of this BulkEnvelopeStatus.  # noqa: E501

        Starting position of the current result set.  # noqa: E501

        :return: The start_position of this BulkEnvelopeStatus.  # noqa: E501
        :rtype: str
        """
        return self._start_position

    @start_position.setter
    def start_position(self, start_position):
        """Sets the start_position of this BulkEnvelopeStatus.

        Starting position of the current result set.  # noqa: E501

        :param start_position: The start_position of this BulkEnvelopeStatus.  # noqa: E501
        :type: str
        """

        self._start_position = start_position

    @property
    def submitted_date(self):
        """Gets the submitted_date of this BulkEnvelopeStatus.  # noqa: E501

          # noqa: E501

        :return: The submitted_date of this BulkEnvelopeStatus.  # noqa: E501
        :rtype: str
        """
        return self._submitted_date

    @submitted_date.setter
    def submitted_date(self, submitted_date):
        """Sets the submitted_date of this BulkEnvelopeStatus.

          # noqa: E501

        :param submitted_date: The submitted_date of this BulkEnvelopeStatus.  # noqa: E501
        :type: str
        """

        self._submitted_date = submitted_date

    @property
    def total_set_size(self):
        """Gets the total_set_size of this BulkEnvelopeStatus.  # noqa: E501

        The total number of items available in the result set. This will always be greater than or equal to the value of the property returning the results in the in the response.  # noqa: E501

        :return: The total_set_size of this BulkEnvelopeStatus.  # noqa: E501
        :rtype: str
        """
        return self._total_set_size

    @total_set_size.setter
    def total_set_size(self, total_set_size):
        """Sets the total_set_size of this BulkEnvelopeStatus.

        The total number of items available in the result set. This will always be greater than or equal to the value of the property returning the results in the in the response.  # noqa: E501

        :param total_set_size: The total_set_size of this BulkEnvelopeStatus.  # noqa: E501
        :type: str
        """

        self._total_set_size = total_set_size

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(BulkEnvelopeStatus, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, BulkEnvelopeStatus):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, BulkEnvelopeStatus):
            return True

        return self.to_dict() != other.to_dict()
