# coding: utf-8

"""
    DocuSign REST API

    The DocuSign REST API provides you with a powerful, convenient, and simple Web services API for interacting with DocuSign.  # noqa: E501

    OpenAPI spec version: v2.1
    Contact: devcenter@docusign.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from docusign_esign.client.configuration import Configuration


class ChunkedUploadResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'checksum': 'str',
        'chunked_upload_id': 'str',
        'chunked_upload_parts': 'list[ChunkedUploadPart]',
        'chunked_upload_uri': 'str',
        'committed': 'str',
        'expiration_date_time': 'str',
        'max_chunked_upload_parts': 'str',
        'max_total_size': 'str',
        'total_size': 'str'
    }

    attribute_map = {
        'checksum': 'checksum',
        'chunked_upload_id': 'chunkedUploadId',
        'chunked_upload_parts': 'chunkedUploadParts',
        'chunked_upload_uri': 'chunkedUploadUri',
        'committed': 'committed',
        'expiration_date_time': 'expirationDateTime',
        'max_chunked_upload_parts': 'maxChunkedUploadParts',
        'max_total_size': 'maxTotalSize',
        'total_size': 'totalSize'
    }

    def __init__(self, _configuration=None, **kwargs):  # noqa: E501
        """ChunkedUploadResponse - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._checksum = None
        self._chunked_upload_id = None
        self._chunked_upload_parts = None
        self._chunked_upload_uri = None
        self._committed = None
        self._expiration_date_time = None
        self._max_chunked_upload_parts = None
        self._max_total_size = None
        self._total_size = None
        self.discriminator = None

        setattr(self, "_{}".format('checksum'), kwargs.get('checksum', None))
        setattr(self, "_{}".format('chunked_upload_id'), kwargs.get('chunked_upload_id', None))
        setattr(self, "_{}".format('chunked_upload_parts'), kwargs.get('chunked_upload_parts', None))
        setattr(self, "_{}".format('chunked_upload_uri'), kwargs.get('chunked_upload_uri', None))
        setattr(self, "_{}".format('committed'), kwargs.get('committed', None))
        setattr(self, "_{}".format('expiration_date_time'), kwargs.get('expiration_date_time', None))
        setattr(self, "_{}".format('max_chunked_upload_parts'), kwargs.get('max_chunked_upload_parts', None))
        setattr(self, "_{}".format('max_total_size'), kwargs.get('max_total_size', None))
        setattr(self, "_{}".format('total_size'), kwargs.get('total_size', None))

    @property
    def checksum(self):
        """Gets the checksum of this ChunkedUploadResponse.  # noqa: E501

          # noqa: E501

        :return: The checksum of this ChunkedUploadResponse.  # noqa: E501
        :rtype: str
        """
        return self._checksum

    @checksum.setter
    def checksum(self, checksum):
        """Sets the checksum of this ChunkedUploadResponse.

          # noqa: E501

        :param checksum: The checksum of this ChunkedUploadResponse.  # noqa: E501
        :type: str
        """

        self._checksum = checksum

    @property
    def chunked_upload_id(self):
        """Gets the chunked_upload_id of this ChunkedUploadResponse.  # noqa: E501

          # noqa: E501

        :return: The chunked_upload_id of this ChunkedUploadResponse.  # noqa: E501
        :rtype: str
        """
        return self._chunked_upload_id

    @chunked_upload_id.setter
    def chunked_upload_id(self, chunked_upload_id):
        """Sets the chunked_upload_id of this ChunkedUploadResponse.

          # noqa: E501

        :param chunked_upload_id: The chunked_upload_id of this ChunkedUploadResponse.  # noqa: E501
        :type: str
        """

        self._chunked_upload_id = chunked_upload_id

    @property
    def chunked_upload_parts(self):
        """Gets the chunked_upload_parts of this ChunkedUploadResponse.  # noqa: E501

          # noqa: E501

        :return: The chunked_upload_parts of this ChunkedUploadResponse.  # noqa: E501
        :rtype: list[ChunkedUploadPart]
        """
        return self._chunked_upload_parts

    @chunked_upload_parts.setter
    def chunked_upload_parts(self, chunked_upload_parts):
        """Sets the chunked_upload_parts of this ChunkedUploadResponse.

          # noqa: E501

        :param chunked_upload_parts: The chunked_upload_parts of this ChunkedUploadResponse.  # noqa: E501
        :type: list[ChunkedUploadPart]
        """

        self._chunked_upload_parts = chunked_upload_parts

    @property
    def chunked_upload_uri(self):
        """Gets the chunked_upload_uri of this ChunkedUploadResponse.  # noqa: E501

          # noqa: E501

        :return: The chunked_upload_uri of this ChunkedUploadResponse.  # noqa: E501
        :rtype: str
        """
        return self._chunked_upload_uri

    @chunked_upload_uri.setter
    def chunked_upload_uri(self, chunked_upload_uri):
        """Sets the chunked_upload_uri of this ChunkedUploadResponse.

          # noqa: E501

        :param chunked_upload_uri: The chunked_upload_uri of this ChunkedUploadResponse.  # noqa: E501
        :type: str
        """

        self._chunked_upload_uri = chunked_upload_uri

    @property
    def committed(self):
        """Gets the committed of this ChunkedUploadResponse.  # noqa: E501

          # noqa: E501

        :return: The committed of this ChunkedUploadResponse.  # noqa: E501
        :rtype: str
        """
        return self._committed

    @committed.setter
    def committed(self, committed):
        """Sets the committed of this ChunkedUploadResponse.

          # noqa: E501

        :param committed: The committed of this ChunkedUploadResponse.  # noqa: E501
        :type: str
        """

        self._committed = committed

    @property
    def expiration_date_time(self):
        """Gets the expiration_date_time of this ChunkedUploadResponse.  # noqa: E501

          # noqa: E501

        :return: The expiration_date_time of this ChunkedUploadResponse.  # noqa: E501
        :rtype: str
        """
        return self._expiration_date_time

    @expiration_date_time.setter
    def expiration_date_time(self, expiration_date_time):
        """Sets the expiration_date_time of this ChunkedUploadResponse.

          # noqa: E501

        :param expiration_date_time: The expiration_date_time of this ChunkedUploadResponse.  # noqa: E501
        :type: str
        """

        self._expiration_date_time = expiration_date_time

    @property
    def max_chunked_upload_parts(self):
        """Gets the max_chunked_upload_parts of this ChunkedUploadResponse.  # noqa: E501

          # noqa: E501

        :return: The max_chunked_upload_parts of this ChunkedUploadResponse.  # noqa: E501
        :rtype: str
        """
        return self._max_chunked_upload_parts

    @max_chunked_upload_parts.setter
    def max_chunked_upload_parts(self, max_chunked_upload_parts):
        """Sets the max_chunked_upload_parts of this ChunkedUploadResponse.

          # noqa: E501

        :param max_chunked_upload_parts: The max_chunked_upload_parts of this ChunkedUploadResponse.  # noqa: E501
        :type: str
        """

        self._max_chunked_upload_parts = max_chunked_upload_parts

    @property
    def max_total_size(self):
        """Gets the max_total_size of this ChunkedUploadResponse.  # noqa: E501

          # noqa: E501

        :return: The max_total_size of this ChunkedUploadResponse.  # noqa: E501
        :rtype: str
        """
        return self._max_total_size

    @max_total_size.setter
    def max_total_size(self, max_total_size):
        """Sets the max_total_size of this ChunkedUploadResponse.

          # noqa: E501

        :param max_total_size: The max_total_size of this ChunkedUploadResponse.  # noqa: E501
        :type: str
        """

        self._max_total_size = max_total_size

    @property
    def total_size(self):
        """Gets the total_size of this ChunkedUploadResponse.  # noqa: E501

          # noqa: E501

        :return: The total_size of this ChunkedUploadResponse.  # noqa: E501
        :rtype: str
        """
        return self._total_size

    @total_size.setter
    def total_size(self, total_size):
        """Sets the total_size of this ChunkedUploadResponse.

          # noqa: E501

        :param total_size: The total_size of this ChunkedUploadResponse.  # noqa: E501
        :type: str
        """

        self._total_size = total_size

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ChunkedUploadResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ChunkedUploadResponse):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ChunkedUploadResponse):
            return True

        return self.to_dict() != other.to_dict()
