# coding: utf-8

"""
    DocuSign REST API

    The DocuSign REST API provides you with a powerful, convenient, and simple Web services API for interacting with DocuSign.  # noqa: E501

    OpenAPI spec version: v2.1
    Contact: devcenter@docusign.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from docusign_esign.client.configuration import Configuration


class WorkspaceItem(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'caller_authorization': 'WorkspaceUserAuthorization',
        'content_type': 'str',
        'created': 'str',
        'created_by_id': 'str',
        'created_by_information': 'WorkspaceUser',
        'extension': 'str',
        'file_size': 'str',
        'file_uri': 'str',
        'id': 'str',
        'is_public': 'str',
        'last_modified': 'str',
        'last_modified_by_id': 'str',
        'last_modified_by_information': 'WorkspaceUser',
        'name': 'str',
        'page_count': 'str',
        'parent_folder_id': 'str',
        'parent_folder_uri': 'str',
        'sha256': 'str',
        'thumb_height': 'str',
        'thumbnail': 'Page',
        'thumb_width': 'str',
        'type': 'str',
        'uri': 'str',
        'user_authorization': 'WorkspaceUserAuthorization'
    }

    attribute_map = {
        'caller_authorization': 'callerAuthorization',
        'content_type': 'contentType',
        'created': 'created',
        'created_by_id': 'createdById',
        'created_by_information': 'createdByInformation',
        'extension': 'extension',
        'file_size': 'fileSize',
        'file_uri': 'fileUri',
        'id': 'id',
        'is_public': 'isPublic',
        'last_modified': 'lastModified',
        'last_modified_by_id': 'lastModifiedById',
        'last_modified_by_information': 'lastModifiedByInformation',
        'name': 'name',
        'page_count': 'pageCount',
        'parent_folder_id': 'parentFolderId',
        'parent_folder_uri': 'parentFolderUri',
        'sha256': 'sha256',
        'thumb_height': 'thumbHeight',
        'thumbnail': 'thumbnail',
        'thumb_width': 'thumbWidth',
        'type': 'type',
        'uri': 'uri',
        'user_authorization': 'userAuthorization'
    }

    def __init__(self, _configuration=None, **kwargs):  # noqa: E501
        """WorkspaceItem - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._caller_authorization = None
        self._content_type = None
        self._created = None
        self._created_by_id = None
        self._created_by_information = None
        self._extension = None
        self._file_size = None
        self._file_uri = None
        self._id = None
        self._is_public = None
        self._last_modified = None
        self._last_modified_by_id = None
        self._last_modified_by_information = None
        self._name = None
        self._page_count = None
        self._parent_folder_id = None
        self._parent_folder_uri = None
        self._sha256 = None
        self._thumb_height = None
        self._thumbnail = None
        self._thumb_width = None
        self._type = None
        self._uri = None
        self._user_authorization = None
        self.discriminator = None

        setattr(self, "_{}".format('caller_authorization'), kwargs.get('caller_authorization', None))
        setattr(self, "_{}".format('content_type'), kwargs.get('content_type', None))
        setattr(self, "_{}".format('created'), kwargs.get('created', None))
        setattr(self, "_{}".format('created_by_id'), kwargs.get('created_by_id', None))
        setattr(self, "_{}".format('created_by_information'), kwargs.get('created_by_information', None))
        setattr(self, "_{}".format('extension'), kwargs.get('extension', None))
        setattr(self, "_{}".format('file_size'), kwargs.get('file_size', None))
        setattr(self, "_{}".format('file_uri'), kwargs.get('file_uri', None))
        setattr(self, "_{}".format('id'), kwargs.get('id', None))
        setattr(self, "_{}".format('is_public'), kwargs.get('is_public', None))
        setattr(self, "_{}".format('last_modified'), kwargs.get('last_modified', None))
        setattr(self, "_{}".format('last_modified_by_id'), kwargs.get('last_modified_by_id', None))
        setattr(self, "_{}".format('last_modified_by_information'), kwargs.get('last_modified_by_information', None))
        setattr(self, "_{}".format('name'), kwargs.get('name', None))
        setattr(self, "_{}".format('page_count'), kwargs.get('page_count', None))
        setattr(self, "_{}".format('parent_folder_id'), kwargs.get('parent_folder_id', None))
        setattr(self, "_{}".format('parent_folder_uri'), kwargs.get('parent_folder_uri', None))
        setattr(self, "_{}".format('sha256'), kwargs.get('sha256', None))
        setattr(self, "_{}".format('thumb_height'), kwargs.get('thumb_height', None))
        setattr(self, "_{}".format('thumbnail'), kwargs.get('thumbnail', None))
        setattr(self, "_{}".format('thumb_width'), kwargs.get('thumb_width', None))
        setattr(self, "_{}".format('type'), kwargs.get('type', None))
        setattr(self, "_{}".format('uri'), kwargs.get('uri', None))
        setattr(self, "_{}".format('user_authorization'), kwargs.get('user_authorization', None))

    @property
    def caller_authorization(self):
        """Gets the caller_authorization of this WorkspaceItem.  # noqa: E501


        :return: The caller_authorization of this WorkspaceItem.  # noqa: E501
        :rtype: WorkspaceUserAuthorization
        """
        return self._caller_authorization

    @caller_authorization.setter
    def caller_authorization(self, caller_authorization):
        """Sets the caller_authorization of this WorkspaceItem.


        :param caller_authorization: The caller_authorization of this WorkspaceItem.  # noqa: E501
        :type: WorkspaceUserAuthorization
        """

        self._caller_authorization = caller_authorization

    @property
    def content_type(self):
        """Gets the content_type of this WorkspaceItem.  # noqa: E501

          # noqa: E501

        :return: The content_type of this WorkspaceItem.  # noqa: E501
        :rtype: str
        """
        return self._content_type

    @content_type.setter
    def content_type(self, content_type):
        """Sets the content_type of this WorkspaceItem.

          # noqa: E501

        :param content_type: The content_type of this WorkspaceItem.  # noqa: E501
        :type: str
        """

        self._content_type = content_type

    @property
    def created(self):
        """Gets the created of this WorkspaceItem.  # noqa: E501

        The UTC DateTime when the workspace item was created.  # noqa: E501

        :return: The created of this WorkspaceItem.  # noqa: E501
        :rtype: str
        """
        return self._created

    @created.setter
    def created(self, created):
        """Sets the created of this WorkspaceItem.

        The UTC DateTime when the workspace item was created.  # noqa: E501

        :param created: The created of this WorkspaceItem.  # noqa: E501
        :type: str
        """

        self._created = created

    @property
    def created_by_id(self):
        """Gets the created_by_id of this WorkspaceItem.  # noqa: E501

          # noqa: E501

        :return: The created_by_id of this WorkspaceItem.  # noqa: E501
        :rtype: str
        """
        return self._created_by_id

    @created_by_id.setter
    def created_by_id(self, created_by_id):
        """Sets the created_by_id of this WorkspaceItem.

          # noqa: E501

        :param created_by_id: The created_by_id of this WorkspaceItem.  # noqa: E501
        :type: str
        """

        self._created_by_id = created_by_id

    @property
    def created_by_information(self):
        """Gets the created_by_information of this WorkspaceItem.  # noqa: E501


        :return: The created_by_information of this WorkspaceItem.  # noqa: E501
        :rtype: WorkspaceUser
        """
        return self._created_by_information

    @created_by_information.setter
    def created_by_information(self, created_by_information):
        """Sets the created_by_information of this WorkspaceItem.


        :param created_by_information: The created_by_information of this WorkspaceItem.  # noqa: E501
        :type: WorkspaceUser
        """

        self._created_by_information = created_by_information

    @property
    def extension(self):
        """Gets the extension of this WorkspaceItem.  # noqa: E501

          # noqa: E501

        :return: The extension of this WorkspaceItem.  # noqa: E501
        :rtype: str
        """
        return self._extension

    @extension.setter
    def extension(self, extension):
        """Sets the extension of this WorkspaceItem.

          # noqa: E501

        :param extension: The extension of this WorkspaceItem.  # noqa: E501
        :type: str
        """

        self._extension = extension

    @property
    def file_size(self):
        """Gets the file_size of this WorkspaceItem.  # noqa: E501

          # noqa: E501

        :return: The file_size of this WorkspaceItem.  # noqa: E501
        :rtype: str
        """
        return self._file_size

    @file_size.setter
    def file_size(self, file_size):
        """Sets the file_size of this WorkspaceItem.

          # noqa: E501

        :param file_size: The file_size of this WorkspaceItem.  # noqa: E501
        :type: str
        """

        self._file_size = file_size

    @property
    def file_uri(self):
        """Gets the file_uri of this WorkspaceItem.  # noqa: E501

          # noqa: E501

        :return: The file_uri of this WorkspaceItem.  # noqa: E501
        :rtype: str
        """
        return self._file_uri

    @file_uri.setter
    def file_uri(self, file_uri):
        """Sets the file_uri of this WorkspaceItem.

          # noqa: E501

        :param file_uri: The file_uri of this WorkspaceItem.  # noqa: E501
        :type: str
        """

        self._file_uri = file_uri

    @property
    def id(self):
        """Gets the id of this WorkspaceItem.  # noqa: E501

          # noqa: E501

        :return: The id of this WorkspaceItem.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this WorkspaceItem.

          # noqa: E501

        :param id: The id of this WorkspaceItem.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def is_public(self):
        """Gets the is_public of this WorkspaceItem.  # noqa: E501

         If true, this supersedes need for bit mask permission with workspaceUserAuthorization  # noqa: E501

        :return: The is_public of this WorkspaceItem.  # noqa: E501
        :rtype: str
        """
        return self._is_public

    @is_public.setter
    def is_public(self, is_public):
        """Sets the is_public of this WorkspaceItem.

         If true, this supersedes need for bit mask permission with workspaceUserAuthorization  # noqa: E501

        :param is_public: The is_public of this WorkspaceItem.  # noqa: E501
        :type: str
        """

        self._is_public = is_public

    @property
    def last_modified(self):
        """Gets the last_modified of this WorkspaceItem.  # noqa: E501

          # noqa: E501

        :return: The last_modified of this WorkspaceItem.  # noqa: E501
        :rtype: str
        """
        return self._last_modified

    @last_modified.setter
    def last_modified(self, last_modified):
        """Sets the last_modified of this WorkspaceItem.

          # noqa: E501

        :param last_modified: The last_modified of this WorkspaceItem.  # noqa: E501
        :type: str
        """

        self._last_modified = last_modified

    @property
    def last_modified_by_id(self):
        """Gets the last_modified_by_id of this WorkspaceItem.  # noqa: E501

        Utc date and time the comment was last updated (can only be done by creator)  # noqa: E501

        :return: The last_modified_by_id of this WorkspaceItem.  # noqa: E501
        :rtype: str
        """
        return self._last_modified_by_id

    @last_modified_by_id.setter
    def last_modified_by_id(self, last_modified_by_id):
        """Sets the last_modified_by_id of this WorkspaceItem.

        Utc date and time the comment was last updated (can only be done by creator)  # noqa: E501

        :param last_modified_by_id: The last_modified_by_id of this WorkspaceItem.  # noqa: E501
        :type: str
        """

        self._last_modified_by_id = last_modified_by_id

    @property
    def last_modified_by_information(self):
        """Gets the last_modified_by_information of this WorkspaceItem.  # noqa: E501


        :return: The last_modified_by_information of this WorkspaceItem.  # noqa: E501
        :rtype: WorkspaceUser
        """
        return self._last_modified_by_information

    @last_modified_by_information.setter
    def last_modified_by_information(self, last_modified_by_information):
        """Sets the last_modified_by_information of this WorkspaceItem.


        :param last_modified_by_information: The last_modified_by_information of this WorkspaceItem.  # noqa: E501
        :type: WorkspaceUser
        """

        self._last_modified_by_information = last_modified_by_information

    @property
    def name(self):
        """Gets the name of this WorkspaceItem.  # noqa: E501

        A simple string description of the item, such as a file name or a folder name.  # noqa: E501

        :return: The name of this WorkspaceItem.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this WorkspaceItem.

        A simple string description of the item, such as a file name or a folder name.  # noqa: E501

        :param name: The name of this WorkspaceItem.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def page_count(self):
        """Gets the page_count of this WorkspaceItem.  # noqa: E501

          # noqa: E501

        :return: The page_count of this WorkspaceItem.  # noqa: E501
        :rtype: str
        """
        return self._page_count

    @page_count.setter
    def page_count(self, page_count):
        """Sets the page_count of this WorkspaceItem.

          # noqa: E501

        :param page_count: The page_count of this WorkspaceItem.  # noqa: E501
        :type: str
        """

        self._page_count = page_count

    @property
    def parent_folder_id(self):
        """Gets the parent_folder_id of this WorkspaceItem.  # noqa: E501

        The ID of the parent folder. This is the GUID of the parent folder, or the special value 'root' for the root folder.  # noqa: E501

        :return: The parent_folder_id of this WorkspaceItem.  # noqa: E501
        :rtype: str
        """
        return self._parent_folder_id

    @parent_folder_id.setter
    def parent_folder_id(self, parent_folder_id):
        """Sets the parent_folder_id of this WorkspaceItem.

        The ID of the parent folder. This is the GUID of the parent folder, or the special value 'root' for the root folder.  # noqa: E501

        :param parent_folder_id: The parent_folder_id of this WorkspaceItem.  # noqa: E501
        :type: str
        """

        self._parent_folder_id = parent_folder_id

    @property
    def parent_folder_uri(self):
        """Gets the parent_folder_uri of this WorkspaceItem.  # noqa: E501

          # noqa: E501

        :return: The parent_folder_uri of this WorkspaceItem.  # noqa: E501
        :rtype: str
        """
        return self._parent_folder_uri

    @parent_folder_uri.setter
    def parent_folder_uri(self, parent_folder_uri):
        """Sets the parent_folder_uri of this WorkspaceItem.

          # noqa: E501

        :param parent_folder_uri: The parent_folder_uri of this WorkspaceItem.  # noqa: E501
        :type: str
        """

        self._parent_folder_uri = parent_folder_uri

    @property
    def sha256(self):
        """Gets the sha256 of this WorkspaceItem.  # noqa: E501

          # noqa: E501

        :return: The sha256 of this WorkspaceItem.  # noqa: E501
        :rtype: str
        """
        return self._sha256

    @sha256.setter
    def sha256(self, sha256):
        """Sets the sha256 of this WorkspaceItem.

          # noqa: E501

        :param sha256: The sha256 of this WorkspaceItem.  # noqa: E501
        :type: str
        """

        self._sha256 = sha256

    @property
    def thumb_height(self):
        """Gets the thumb_height of this WorkspaceItem.  # noqa: E501

          # noqa: E501

        :return: The thumb_height of this WorkspaceItem.  # noqa: E501
        :rtype: str
        """
        return self._thumb_height

    @thumb_height.setter
    def thumb_height(self, thumb_height):
        """Sets the thumb_height of this WorkspaceItem.

          # noqa: E501

        :param thumb_height: The thumb_height of this WorkspaceItem.  # noqa: E501
        :type: str
        """

        self._thumb_height = thumb_height

    @property
    def thumbnail(self):
        """Gets the thumbnail of this WorkspaceItem.  # noqa: E501


        :return: The thumbnail of this WorkspaceItem.  # noqa: E501
        :rtype: Page
        """
        return self._thumbnail

    @thumbnail.setter
    def thumbnail(self, thumbnail):
        """Sets the thumbnail of this WorkspaceItem.


        :param thumbnail: The thumbnail of this WorkspaceItem.  # noqa: E501
        :type: Page
        """

        self._thumbnail = thumbnail

    @property
    def thumb_width(self):
        """Gets the thumb_width of this WorkspaceItem.  # noqa: E501

          # noqa: E501

        :return: The thumb_width of this WorkspaceItem.  # noqa: E501
        :rtype: str
        """
        return self._thumb_width

    @thumb_width.setter
    def thumb_width(self, thumb_width):
        """Sets the thumb_width of this WorkspaceItem.

          # noqa: E501

        :param thumb_width: The thumb_width of this WorkspaceItem.  # noqa: E501
        :type: str
        """

        self._thumb_width = thumb_width

    @property
    def type(self):
        """Gets the type of this WorkspaceItem.  # noqa: E501

        The type of the workspace item. Valid values are file, folder.  # noqa: E501

        :return: The type of this WorkspaceItem.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this WorkspaceItem.

        The type of the workspace item. Valid values are file, folder.  # noqa: E501

        :param type: The type of this WorkspaceItem.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def uri(self):
        """Gets the uri of this WorkspaceItem.  # noqa: E501

          # noqa: E501

        :return: The uri of this WorkspaceItem.  # noqa: E501
        :rtype: str
        """
        return self._uri

    @uri.setter
    def uri(self, uri):
        """Sets the uri of this WorkspaceItem.

          # noqa: E501

        :param uri: The uri of this WorkspaceItem.  # noqa: E501
        :type: str
        """

        self._uri = uri

    @property
    def user_authorization(self):
        """Gets the user_authorization of this WorkspaceItem.  # noqa: E501


        :return: The user_authorization of this WorkspaceItem.  # noqa: E501
        :rtype: WorkspaceUserAuthorization
        """
        return self._user_authorization

    @user_authorization.setter
    def user_authorization(self, user_authorization):
        """Sets the user_authorization of this WorkspaceItem.


        :param user_authorization: The user_authorization of this WorkspaceItem.  # noqa: E501
        :type: WorkspaceUserAuthorization
        """

        self._user_authorization = user_authorization

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(WorkspaceItem, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, WorkspaceItem):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, WorkspaceItem):
            return True

        return self.to_dict() != other.to_dict()
